unit useclist;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, slstbox, ExtCtrls, ComCtrls {$IFDEF VER120}, ImgList {$ENDIF};

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    SectionListBox2: TSectionListBox;
    ListBox1: TListBox;
    Label1: TLabel;
    subitem: TLabel;
    Button3: TButton;
    Button4: TButton;
    ImageList1: TImageList;
    CheckBox1: TCheckBox;
    Button5: TButton;
    CheckBox2: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure SectionListBox2ExpandSection(Sender: TObject;
      sectionidx: Integer);
    procedure SectionListBox2ContractSection(Sender: TObject;
      sectionidx: Integer);
    procedure SectionListBox2SubItemClick(Sender: TObject; sectionidx,
      subitemidx: Integer);
    procedure SectionListBox2DeleteSubItem(Sender: TObject; sectionidx,
      subitemidx: Integer; var allow: Boolean);
    procedure SectionListBox2InsertSubItem(Sender: TObject; sectionidx,
      subitemidx: Integer; var subitem: String);
    procedure SectionListBox2DeleteSection(Sender: TObject;
      sectionidx: Integer; var allow: Boolean);
    procedure SectionListBox2InsertSection(Sender: TObject;
      sectionidx: Integer; section: TListSection);
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  sectionlistbox2.expandall;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 sectionlistbox2.contractall;
end;

procedure TForm1.SectionListBox2ExpandSection(Sender: TObject;
  sectionidx: Integer);
begin
 listbox1.items.Add('expand section '+inttostr(sectionidx));
end;

procedure TForm1.SectionListBox2ContractSection(Sender: TObject;
  sectionidx: Integer);
begin
 listbox1.items.Add('contract section '+inttostr(sectionidx));

end;

procedure TForm1.SectionListBox2SubItemClick(Sender: TObject; sectionidx,
  subitemidx: Integer);
begin
 subitem.caption:=sectionlistbox2.GetSectionSubItem(sectionidx,subitemidx);
 listbox1.items.add('section: '+inttostr(sectionidx)+' subitem:'+inttostr(subitemidx));
end;

procedure TForm1.SectionListBox2DeleteSubItem(Sender: TObject; sectionidx,
  subitemidx: Integer; var allow: Boolean);
begin
 with SectionListBox2 do
 allow:=messagedlg('Delete item '+GetSectionSubItem(sectionidx,subitemidx)+' ?',
                    mtConfirmation,[mbYes,mbNo],0)=mrYes;
end;

procedure TForm1.SectionListBox2InsertSubItem(Sender: TObject; sectionidx,
  subitemidx: Integer; var subitem: String);
begin
 subitem:='This is a new subitem';
end;

procedure TForm1.SectionListBox2DeleteSection(Sender: TObject;
  sectionidx: Integer; var allow: Boolean);
begin
 with (SectionListBox2.Sections.Items[sectionidx] as TListSection) do
 allow:=messagedlg('Delete section '+caption+' ?',
                    mtConfirmation,[mbYes,mbNo],0)=mrYes;
end;

procedure TForm1.SectionListBox2InsertSection(Sender: TObject;
  sectionidx: Integer; section: TListSection);
begin
 section.Caption:='Second hand cars';
 section.Subitems.Add('BMW'+#9+'750iL'+#9+'1995');
 section.Subitems.Add('Mercedes'+#9+'SLK230'+#9+'1997');
 section.Subitems.Add('Audi'+#9+'A4'+#9+'1996');

end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 with SectionListBox2.Sections.Add as TListSection do
  begin
   Caption:='Italian sport cars';
   Subitems.Add('Ferrari'+#9+'F355'+#9+'1995');
   Subitems.Add('Lamborghini'+#9+'Diablo'+#9+'1997');
   Subitems.Add('DeTomaso'+#9+'Pantera'+#9+'1985');
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 with SectionListBox2.Sections do
  begin
   if (Count>0) then (Items[Count-1] as TListSection).Free;
  end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
 (sectionlistbox2.sections.items[0] as TListSection).Fixed:=checkbox1.checked;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
 sectionlistbox2.optimizetabs(10);
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
 sectionlistbox2.flat:=checkbox2.checked;
end;

end.
